
proc XML:decrypt {chdata} {
    return [string map {& &amp; < &lt; > &gt; \" &quot; ' &apos; 
			\x00 " " \x01 " " \x02 " " \x03 " "
			\x04 " " \x05 " " \x06 " " \x07 " "
			\x08 " "                   \x0B " "
			\x0C " "          \x0E " " \x0F " "
			\x10 " " \x11 " " \x12 " " \x13 " "
			\x14 " " \x15 " " \x16 " " \x17 " "
			\x18 " " \x19 " " \x1A " " \x1B " "
			\x1C " " \x1D " " \x1E " " \x1F " "
		        \x7F " "} $chdata]
}

proc XML:extract {vars} {
set listvar ""
set varname ""
set value ""

set quotchar ""
set place1 ""
set place2 ""
set place3 ""
set tmp1 ""
set tmp2 ""

set tmp ""

while {$tmp==""} {
  if {[set place1 [findfirst "=" $vars 0]]==-1} {return $listvar}

  set varname [string range $vars 0 [expr $place1-1]]

  set tmp1 [findfirst {"} $vars $place1]
  set tmp2 [findfirst {'} $vars $place1]


  if {$tmp1<$tmp2 && $tmp1!="-1"} {set place2 $tmp1; set quotchar {"}} \
    elseif {$tmp1>$tmp2 && $tmp2=="-1"} {set place2 $tmp1; set quotchar {"}} \
    elseif {$tmp2<$tmp1 && $tmp2!="-1"} {set place2 $tmp2; set quotchar {'}} \
    elseif {$tmp2>$tmp1 && $tmp1=="-1"} {set place2 $tmp2; set quotchar {'}} \
    else {return $listvar}

  if {$place2==-1} {return $listvar}

  if {[string trim [string range $vars [expr $place1+1] [expr $place2-1]]]!=""} {set vars [string range $vars [expr $place1+1] end]; continue}    ;#If there is something like {name=  abcd='aa'} ,skip name parameter

  incr place2
  set place3 [expr [findfirst $quotchar $vars $place2]-1]
  if {$place3==-2} {return $listvar}

  set varname [string trimleft $varname]
  set value [XML:decrypt [string range $vars $place2 $place3]]

  lappend listvar $varname
  lappend listvar $value

  set vars [string range $vars [expr $place3+2] end]
  }
}

proc rtrimleft {bigstr srcstr} {
set istring1 [string length $srcstr]
if {$srcstr == [string range $bigstr 0 [expr $istring1-1]]} {
  return [string range $bigstr $istring1 end] }
}

proc findfirst {srcstr bigstr start} {
set text [string range $bigstr $start end]
if {[set index [string first $srcstr $text]]!=-1} \
  {return [expr $start+$index]} else {return -1}
}

