
set country(names) {
	"afghanistan" "albania" "algeria" "american Samoa"
	"andorra" "angola" "anguilla" "antarctica"
	"antigua and barbuda" "argentina" "armenia" "aruba"
	"australia" "austria" "azerbaijan" "bahamas"
	"bahrain" "bangladesh" "barbados" "belarus"
	"belgium" "belize" "benin" "bermuda"
	"Bhutan" "Bolivia" "Bosnia" "Botswana"
	"Bouvet island" "Brazil" "British indian ocean territory" "Brunei Darussalam"
	"Bulgaria" "Burkina faso" "Burundi" "Belarus"
	"Cambodia" "Cameroon" "Canada" "Cap verde"
	"cayman islands" "central african republic" "chad" "chile"
	"china" "christmas island" "cocos (keeling) islands" "colombia"
	"comoros" "congo" "cook islands" "costa rica"
	"cote d'ivoire" "croatia" "hrvatska" "cuba"
	"cyprus" "czechoslovakia" "denmark" "djibouti"
	"dominica" "dominican republic" "east timor" "ecuador"
	"egypt" "el salvador" "equatorial guinea" "estonia"
	"ethiopia" "falkland islands" "malvinas" "faroe islands"
	"fiji" "finland" "france" "french guiana"
	"french polynesia" "french southern territories" "gabon" "gambia"
	"georgia" "germany" "deutschland" "ghana"
	"gibraltar" "greece" "greenland" "grenada"
	"guadeloupe" "guam" "guatemala" "guinea"
	"guinea bissau" "gyana" "haiti" "heard and mc donald islands"
	"honduras" "hong kong" "hungary" "iceland"
	"india" "indonesia" "iran" "iraq"
	"ireland" "israel" "italy" "jamaica"
	"japan" "jordan" "kazakhstan" "kenya"
	"kiribati" "north korea" "south korea" "kuwait"
	"kyrgyzstan" "laos" "latvia" "lebanon"
	"lesotho" "liberia" "libyan arab jamahiriya" "liechtenstein"
	"lithuania" "luxembourg" "macau" "macedonia"
	"madagascar" "malawi" "malaysia" "maldives"
	"mali" "malta" "marshall islands" "martinique"
	"mauritania" "mauritius" "mexico" "micronesia"
	"moldova" "monaco" "mongolia" "montserrat"
	"morocco" "mozambique" "myanmar" "namibia"
	"nauru" "nepal" "netherlands" "netherlands antilles"
	"neutral zone" "new caledonia" "new zealand" "nicaragua"
	"niger" "nigeria" "niue" "norfolk island"
	"northern mariana islands" "norway" "oman" "pakistan"
	"palau" "panama" "papua new guinea" "paraguay"
	"peru" "philippines" "pitcairn" "poland"
	"portugal" "puerto rico" "qatar" "reunion"
	"romania" "russian federation" "rwanda" "saint kitts and nevis"
	"saint lucia" "saint vincent and the grenadines" "samoa" "san marino"
	"sao tome and principe" "saudi arabia" "senegal" "seychelles"
	"sierra leone" "singapore" "slovenia" "solomon islands"
	"somalia" "south africa" "spain" "sri lanka"
	"st. helena" "st. pierre and miquelon" "sudan" "suriname"
	"svalbard and jan mayen islands" "swaziland" "sweden" "switzerland"
	"cantons of helvetia" "syrian arab republic" "taiwan" "tajikistan"
	"tanzania" "thailand" "togo" "tokelau"
	"tonga" "trinidad and tobago" "tunisia" "turkey"
	"turkmenistan" "turks and caicos islands" "tuvalu" "uganda"
	"ukraine" "united arab emirates" "united kingdom" "great britain"
	"united states of america" "united states minor outlying islands" "uruguay"
	"soviet union" "uzbekistan" "vanuatu" "vatican city state" "venezuela"
	"viet nam" "virgin islands (us)" "virgin islands (uk)" "wallis and futuna islands"
	"western sahara" "yemen" "yugoslavia" "zaire"
	"zambia" "zimbabwe" "commercial organization (us)" "educational institution (us)"
	"networking organization (us)" "military (us)" "non-profit organization (us)"
	"government (us)" "korea - democratic people's republic of" "korea - republic of"
	"lao peoples' democratic republic" "russia" "slovakia" "czech"
}

set country(domains) {
	af al dz as ad ao ai aq ag ar am aw au at az bs bh bd bb by be
	bz bj bm bt bo ba bw bv br io bn bg bf bi by kh cm ca cv ky cf
	td cl cn cx cc co km cg ck cr ci hr hr cu cy cs dk dj dm do tp
	ec eg sv gq ee et fk fk fo fj fi fr gf pf tf ga gm ge de de gh
	gi gr gl gd gp gu gt gn gw gy ht hm hn hk hu is in id ir iq ie
	il it jm jp jo kz ke ki kp kr kw kg la lv lb ls lr ly li lt lu
	mo mk mg mw my mv ml mt mh mq mr mu mx fm md mc mn ms ma mz mm
	na nr np nl an nt nc nz ni ne ng nu nf mp no om pk pw pa pg py
	pe ph pn pl pt pr qa re ro ru rw kn lc vc ws sm st sa sn sc sl
	sg si sb so za es lk sh pm sd sr sj sz se ch ch sy tw tj tz th
	tg tk to tt tn tr tm tc tv ug ua ae uk gb us um uy su uz vu va
	ve vn vi vg wf eh ye yu zr zm zw com edu net mil org gov kp kr
	la su sk cz
}
hook::add message domains 115
set opt(tld) 1
proc domains {from type body} {

	if {[cmd "$body" "tld"]} {
		global country
		set dom [string tolower [string range "$body" 4 [string length "$body"]]]
		set pos [lsearch -exact $country(domains) "$dom"]
		if {$pos != -1} {
			if {"$type"=="groupchat"} {
				gm "$from" "   .$dom: [lindex $country(names) $pos]."
			} else {
				pm "$from" "   .$dom: [lindex $country(names) $pos]."
			}
		} else {
			if {"$type"=="groupchat"} {
				gm "$from" "   $dom  ."
			} else {
				pm "$from" "   $dom  ."
			}
		}
		return stop
	}
}