proc msgreplacesymbols { text } {
   set text [string map {4  3  6  0  9  @  (  <  1 i    i      i} $text]
#  regsub -all -nocase -- {[\`\~\!\@\$\%\^\&\*\(\)\-\_\=\+\|\{\}\:\"\<\>\?\[\]\;\'\,\.\/\\#]} $text " " text
   return $text
}

proc msgreplacetranslit { text } {
   set text [string map {z  x  c  v  b  n  m  a  s  d  f  g  h  j  k  l  q  w  e  r  t  y  u  i  o  p } $text]
   return $text
}

proc msgreplacetranslitext { text } {
   set text [string map {ya  yu  ch  sh  ts  zh  '  `  z  x  c  v  b  n  m  a  s  d  f  g  h  j  k  l  q  w  e  r  t  y  u  i  o  p } $text]
   return $text
}

proc msgcheck { body } {
   global bw
   set text " [string tolower $body] "
   set text1 [msgreplacesymbols $text]
   set text2 [msgreplacetranslit $text]
   set text3 [msgreplacetranslitext $text]
   
   set text4 [msgreplacetranslit $text1]
   set text5 [msgreplacetranslitext $text1]

	for {set x 0} {$x<[llength $bw]} {incr x} {
		set tmp [lindex $bw $x]
		if {[string match "*$tmp*" $text]} {return 1
		} elseif {[string match "*$tmp*" $text1]} {return 2
		} elseif {[string match "*$tmp*" $text2]} {return 3
		} elseif {[string match "*$tmp*" $text3]} {return 4
		} elseif {[string match "*$tmp*" $text4]} {return 5
		} elseif {[string match "*$tmp*" $text5]} {return 6}
	}

return 0
}

hook::add message bot:cenzor 10
proc bot:cenzor {from type body} {
global opt
set a bot:cenzor
set ifadm [ifadmin $from]
	if {$opt(cenzor)>0} {
		::debug $a "opt(cenzor)" ON
		if {[msgcheck $body]>0} {
			::debug $a "message" "is not cenzored"
			set conf [node_from_jid $from]
			set serv [server_from_jid $from]
			set nick [resource_from_jid $from]
			if {$ifadm<4} {
				::debug $a "not admin moder message" KICK
				jlib::outmsg "<iq to='[user_from_jid $from]' type='set' xml:lang='ru'><query xmlns='http://jabber.org/protocol/muc#admin'><item nick='[resource_from_jid $from]' role='none'/></query></iq>"
				return
			} else {
				if {$ifadm==6} {return}
				if {$ifadm<6} {
					::debug $a "no censored message by BOTadmin or BOTowner" "do nothing"
					gmsg "$conf" "$serv" "$nick" " !!"
				}
			}
		}
	}
}