proc readadminslist { } {
global bot admins enc hd
	set admins ""
	set file [open [file join "$hd" "taho" "config" "admins.txt"]]
	set text [string tolower [encoding convertfrom $enc [read -nonewline $file]]]
	set admins [split $text " "]
	close $file
	putlog "INFO:      "
}

proc readbadwords { } {
global bw enc hd
	set bw ""
	if {[set filein [open [file join "$hd" "taho" "config" "badwords.txt"] "r" ]]!=0} {
		set bw [split [gets $filein] ";"]
		close $filein
		putlog "INFO:       "
	} else {putlog "ERROR:    taho/config/badwords.txt!"}
}

proc readconflist { } {
global con enc hd
	if {[set filein [open [file join "$hd" "taho" "config" "conflist.txt"] "r" ]]!=0} {
		while {[set getconf [encoding convertfrom $enc [gets $filein]]]>0} {
			lappend confa $getconf
			putlog "INFO:    $getconf"
		}
	} else {putlog "ERROR:      "}
	set con $confa
	close $filein
}

proc readaflist { } {
global af enc hd
	if {[set filein [open [file join "$hd" "taho" "misc" "aforizm.txt"] "r" ]]!=0} {
		fconfigure $filein -encoding $enc
		while {[set getaf [gets $filein]]>0} {
			lappend af "$getaf"
		}
	} else {putlog "ERROR:     !"}
	putlog "INFO:  [llength $af] "
	close $filein
}

proc readanlist { } {
global an enc hd

	if {[set filein [open [file join "$hd" "taho" "misc" "anekdot.txt"] "r" ]]!=0} {
		fconfigure $filein -encoding $enc
		set line [gets $filein]

		while {$line!="==="} {
			set anek ":"
			if {$line=="+++"} {
				set line [gets $filein]
				while {$line!="---"} {
				append anek "\n$line"
				set line [gets $filein]
			}
			lappend an $anek
		}
		set line [gets $filein]
		}
	}
	close $filein
}

proc readhelp { } {
global allhelp enc hd

	set file [open [file join "$hd" "taho" "help" "help.txt"]]
	set help ""
		while {[set help [encoding convertfrom $enc [gets $file]]]>0} {
		set allhelp($help) [encoding convertfrom $enc [gets $file]]
		#putlog "INFO: allhelp($help) $allhelp($help)"
	}
	close $file
	putlog "INFO:    "
}

proc readoptions { } {
global opt enc hd

	set file [open [file join "$hd" "taho" "config" "options.txt"]]
	set op ""
	while {[set op [encoding convertfrom $enc [gets $file]]]>0} {
		set opt($op) [encoding convertfrom $enc [gets $file]]
	}
	close $file
	putlog "INFO:     "
}

proc fileload {body type conf serv nick} {
set a fileload 
set curdir [pwd]
::debug $a "curdir" "$curdir"
set text [string range $body 5 [string length $body]]
::debug $a "text" "$text"
set com [split $text "*"]
::debug $a "com" "$com"
	if {[string match [lindex $com 0] "/"]} {
		cd [lindex $com 0]
		::debug $a "cd" "[lindex $com 0]"
	} else {::debug $a "directory" "not change"}
		if {[lindex $com 1]!=""} {
		set ret [readfile_linestolist [lindex $com 1]]
	} else {::debug $a "Null file. text==>" "$text"}
cd "$curdir"
::debug $a "set dir" "$curdir"
return $ret
}

proc readfile_linestolist {rfile} {
	set a readfile_linestolist
	if {[set filein [open "$rfile" "r" ]]!=0} {
		::debug $a "File $rfile" "OK"
		while {[set getline [gets $filein]]>0} {
			::debug $a "line" "readed"
			lappend txt $getline
			::debug $a "line" "$getline"
		}
		::debug $a "File line" "not readed"
	} else {putlog "ERROR:    "}
	close $filein
	::debug $a "file $rfile" "Closed"
	return $txt
}