hook::add message bot:ping 30
set opt(ping) 1
proc bot:ping {from type body} {
global mucinfo name opt
set a ping
	if {[cmd "$body" ping]} {
		set data [createtag query -vars [list xmlns "jabber:iq:version"]]
	   
		if {[string length $body]>4} {
		   if {[string range "$body" 4 4]!=" "} {

				if {"$type"=="groupchat"} {
					gm "$from" "  ?"
					return stop
				} else {
					pm "$from" "  ?"
					return stop
				}
			} else {
				if {[string length "$body"]>5} {
					set to [string trim [string range $body 5 [string length $body]]]
					if {"$to"!="$name([user_from_jid $from])"} {

						set frm "[user_from_jid $from]/$to"
						if {[info exists mucinfo(af,$frm)]} {
							::debug $a "affiliation is available" "$mucinfo(af,$frm)"
							::debug $a "command from" "$from"
							set rtime [clock clicks -milliseconds]
							if {"[resource_from_jid $from]"=="$to"} {
								jlib::send_iq "get" "$data" -to "$frm" -command "ping:reply {$from} $type {you} $rtime"
							} else {
								jlib::send_iq "get" "$data" -to "$frm" -command "ping:reply {$from} $type {$to} $rtime"
							}
							return stop
						} else {
							::debug $a "bad request" "[string range $body 5 [string length $body]]"
							if {"$type"=="groupchat"} {
								::debug $a "answer sended to:" groupchat
								gm "$from" " ."
								return stop
							} else {
								::debug $a "answer sended to:" chat
								pm "$from" " ."
							}
							return stop
						}
					} else {
						::debug $a "request from" ME
						if {"$type"=="groupchat"} {
							gm "$from" "    "
						} else {
							pm "$from" "      ... "
						}
						return stop
					}
				} else {
					if {"$type"=="groupchat"} {
						gm "$from" "    ?"
						return stop
					} else {
						pm "$from" "    ?"
						return stop
					}
				}
			}
		} else {
			::debug $a "request from" himself
			set rtime [clock clicks -milliseconds]
			jlib::send_iq "get" "$data" -to "$from" -command "ping:reply {$from} $type {you} $rtime"
			return stop
		}
	}
}

proc createtag {tagname args} {

	set isempty 1
	set vars    ""
	set chdata  ""
	set subtags ""

	foreach {attr val} $args {
		switch -- $attr {
			-empty   {set isempty $val}
			-vars    {set vars $val}
			-chdata  {set chdata $chdata$val}
			-subtags {set subtags $val}
		}
	}

	set retext [list $tagname $vars $isempty $chdata]
	foreach a $subtags {lappend retext $a}

	return $retext
}
