hook::add message bot:version 35
set opt(version) 1
proc bot:version {from type body} {
global name
set a version
	if {[cmd "$body" version]} {
	set data [createtag query -vars [list xmlns "jabber:iq:version"]]
		if {[string length $body]>7} {
			if {[string range "$body" 7 7]!=" "} {
				if {"$type"=="groupchat"} {
					gm "$from" "  ?"
					return stop
				} else {
					pm "$from" "  ?"
					return stop
				}
			} else {
				if {[string length "$body"]>8} {
					set to [string trim [string range $body 7 [string length $body]]]
					if {"$to"!="$name([user_from_jid $from])"} {
						set frm "[user_from_jid $from]/$to"
						if {[info exists mucinfo(af,$frm)]} {
							::debug $a "affiliation is available" "$mucinfo(af,$frm)"
							::debug $a "command from" "$from"
							if {"[resource_from_jid $from]"=="$to"} {
								jlib::send_iq "get" "$data" -to "$frm" -command "version:reply {$from} $type {}"
							} else {
								jlib::send_iq "get" "$data" -to "$frm" -command "version:reply {$from} $type {$to}"
							}
							return stop
						} else {
							::debug $a "bad request" "$to"
							if {"$type"=="groupchat"} {
								::debug $a "answer sended to:" groupchat
								gm "$from" " ."
								return stop
							} else {
								::debug $a "answer sended to:" chat
								pm "$from" " ..."
							}
							return stop
						}
					} else {
						global tcl_platform
						set answ "  .      Tcl (Tool Command Language)\n Tcl- [info tclversion]\n  -$tcl_platform(os) $tcl_platform(osVersion)"
						if { $type=="groupchat"} {
							gm "$from" "$answ"
						} else {
							pm "$from" "$answ"
						}
						return stop
					}
				} else {
					if {"$type"=="groupchat"} {
						gm "$from" "    ?"
						return stop
					} else {
						pm "$from" "    ?"
						return stop
					}
				}
			}
		} else {
			::debug $a "request from" himself
			jlib::send_iq "get" "$data" -to "$from" -command "version:reply {$from} $type {}"
			return stop
		}
	}
}

proc createtag {tagname args} {

	set isempty 1
	set vars    ""
	set chdata  ""
	set subtags ""

	foreach {attr val} $args {
		switch -- $attr {
			-empty   {set isempty $val}
			-vars    {set vars $val}
			-chdata  {set chdata $chdata$val}
			-subtags {set subtags $val}
		}
	}

	set retext [list $tagname $vars $isempty $chdata]
	foreach a $subtags {lappend retext $a}

	return $retext
}
